| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Read/Write of Multi-Byte Streams (UC3)
Read/Write of Multi-Byte Streams

Endpoint data stream transmission and reception management for the Atmel AVR32 UC3 architecture. More...

## Stream functions for null data
uint8_t | Endpoint_Discard_Stream (uint16_t Length, uint16_t *const BytesProcessed)
uint8_t | Endpoint_Null_Stream (uint16_t Length, uint16_t *const BytesProcessed)

## Stream functions for RAM source/destination data
uint8_t | Endpoint_Write_Stream_LE (const void *const Buffer, uint16_t Length, uint16_t *const BytesProcessed) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Write_Stream_BE (const void *const Buffer, uint16_t Length, uint16_t *const BytesProcessed) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Read_Stream_LE (void *const Buffer, uint16_t Length, uint16_t *const BytesProcessed) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Read_Stream_BE (void *const Buffer, uint16_t Length, uint16_t *const BytesProcessed) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Write_Control_Stream_LE (const void *const Buffer, uint16_t Length) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Write_Control_Stream_BE (const void *const Buffer, uint16_t Length) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Read_Control_Stream_LE (void *const Buffer, uint16_t Length) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | Endpoint_Read_Control_Stream_BE (void *const Buffer, uint16_t Length) ATTR_NON_NULL_PTR_ARG(1)

## Detailed Description

Functions, macros, variables, enums and types related to data reading and writing of data streams from and to endpoints.

## Function Documentation

uint8_t Endpoint_Discard_Stream | ( | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads and discards the given number of bytes from the currently selected endpoint's bank, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Discard_Stream(512, NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Discard_Stream(512, &BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [in] | Length | Number of bytes to discard via the currently selected endpoint.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Null_Stream | ( | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes a given number of zeroed bytes to the currently selected endpoint's bank, sending full packets to the host as needed. The last packet is not automatically sent once the remaining bytes have been written; the user is responsible for manually sending the last packet to the host via the Endpoint_ClearIN() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Null_Stream(512, NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Null_Stream(512, &BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [in] | Length | Number of zero bytes to send via the currently selected endpoint.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Read_Control_Stream_BE | ( | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Reads the given number of bytes from the CONTROL endpoint from the given buffer in big endian, discarding fully read packets from the host as needed. The device IN acknowledgement is not automatically sent after success or failure states; the user is responsible for manually sending the status IN packet to finalize the transfer's status stage via the Endpoint_ClearIN() macro.

Note
  This function automatically sends the last packet in the data stage of the transaction; when the function returns, the user is responsible for clearing the status stage of the transaction. Note that the status stage packet is sent or received in the opposite direction of the data flow.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  [out] | Buffer | Pointer to the destination data buffer to write to.
  [in] | Length | Number of bytes to send via the currently selected endpoint.

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Read_Control_Stream_LE | ( | void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Reads the given number of bytes from the CONTROL endpoint from the given buffer in little endian, discarding fully read packets from the host as needed. The device IN acknowledgement is not automatically sent after success or failure states; the user is responsible for manually sending the status IN packet to finalize the transfer's status stage via the Endpoint_ClearIN() macro.

Note
  This function automatically sends the last packet in the data stage of the transaction; when the function returns, the user is responsible for clearing the status stage of the transaction. Note that the status stage packet is sent or received in the opposite direction of the data flow.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  [out] | Buffer | Pointer to the destination data buffer to write to.
  [in] | Length | Number of bytes to send via the currently selected endpoint.

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Read_Stream_BE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the endpoint from the given buffer in big endian, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [out] | Buffer | Pointer to the destination data buffer to write to.
  [in] | Length | Number of bytes to send via the currently selected endpoint.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Read_Stream_LE | ( | void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Reads the given number of bytes from the endpoint from the given buffer in little endian, discarding fully read packets from the host as needed. The last packet is not automatically discarded once the remaining bytes has been read; the user is responsible for manually discarding the last packet from the host via the Endpoint_ClearOUT() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes empty while there is still data to process (and after the current packet has been acknowledged) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Read_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Read_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [out] | Buffer | Pointer to the destination data buffer to write to.
  [in] | Length | Number of bytes to send via the currently selected endpoint.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be read at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Write_Control_Stream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Writes the given number of bytes to the CONTROL type endpoint from the given buffer in big endian, sending full packets to the host as needed. The host OUT acknowledgement is not automatically cleared in both failure and success states; the user is responsible for manually clearing the status OUT packet to finalize the transfer's status stage via the Endpoint_ClearOUT() macro.

Note
  This function automatically sends the last packet in the data stage of the transaction; when the function returns, the user is responsible for clearing the status stage of the transaction. Note that the status stage packet is sent or received in the opposite direction of the data flow.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  [in] | Buffer | Pointer to the source data buffer to read from.
  [in] | Length | Number of bytes to read for the currently selected endpoint into the buffer.

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Write_Control_Stream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length
| ) |  |

Writes the given number of bytes to the CONTROL type endpoint from the given buffer in little endian, sending full packets to the host as needed. The host OUT acknowledgement is not automatically cleared in both failure and success states; the user is responsible for manually clearing the status OUT packet to finalize the transfer's status stage via the Endpoint_ClearOUT() macro.

Note
  This function automatically sends the last packet in the data stage of the transaction; when the function returns, the user is responsible for clearing the status stage of the transaction. Note that the status stage packet is sent or received in the opposite direction of the data flow.
  This routine should only be used on CONTROL type endpoints.

Warning
  Unlike the standard stream read/write commands, the control stream commands cannot be chained together; i.e. the entire stream data must be read or written at the one time.

Parameters

  [in] | Buffer | Pointer to the source data buffer to read from.
  [in] | Length | Number of bytes to read for the currently selected endpoint into the buffer.

Returns
  A value from the Endpoint_ControlStream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Write_Stream_BE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the endpoint from the given buffer in big endian, sending full packets to the host as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Endpoint_ClearIN() macro.

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [in] | Buffer | Pointer to the source data buffer to read from.
  [in] | Length | Number of bytes to read for the currently selected endpoint into the buffer.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.

uint8_t Endpoint_Write_Stream_LE | ( | const void *const | Buffer,
|  | uint16_t | Length,
|  | uint16_t *const | BytesProcessed
| ) |  |

Writes the given number of bytes to the endpoint from the given buffer in little endian, sending full packets to the host as needed. The last packet filled is not automatically sent; the user is responsible for manually sending the last written packet to the host via the Endpoint_ClearIN() macro.

If the BytesProcessed parameter is `NULL`, the entire stream transfer is attempted at once, failing or succeeding as a single unit. If the BytesProcessed parameter points to a valid storage location, the transfer will instead be performed as a series of chunks. Each time the endpoint bank becomes full while there is still data to process (and after the current packet transmission has been initiated) the BytesProcessed location will be updated with the total number of bytes processed in the stream, and the function will exit with an error code of ENDPOINT_RWSTREAM_IncompleteTransfer. This allows for any abort checking to be performed in the user code - to continue the transfer, call the function again with identical parameters and it will resume until the BytesProcessed value reaches the total transfer length.

Single Stream Transfer Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
if ((ErrorCode = Endpoint_Write_Stream_LE(DataStream, sizeof(DataStream),
NULL)) != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Partial Stream Transfers Example:

uint8_t DataStream[512];
uint8_t ErrorCode;
uint16_t BytesProcessed;
BytesProcessed = 0;
while ((ErrorCode = Endpoint_Write_Stream_LE(DataStream, sizeof(DataStream),
&BytesProcessed)) == ENDPOINT_RWSTREAM_IncompleteTransfer)
{
// Stream not yet complete - do other actions here, abort if required
}
if (ErrorCode != ENDPOINT_RWSTREAM_NoError)
{
// Stream failed to complete - check ErrorCode here
}

Note
  This routine should not be used on CONTROL type endpoints.

Parameters

  [in] | Buffer | Pointer to the source data buffer to read from.
  [in] | Length | Number of bytes to read for the currently selected endpoint into the buffer.
  [in] | BytesProcessed | Pointer to a location where the total number of bytes processed in the current transaction should be updated, `NULL` if the entire stream should be written at once.

Returns
  A value from the Endpoint_Stream_RW_ErrorCodes_t enum.